﻿' **********************************************************************************
' Hinweis:
' Projekteigenschaften -> Ziel CPU: AnyCPU -> 32-Bit bevorzugen Häkchen raus!
' Sonst gibt es Probleme beim PreviewHandler für PDF unter einem 64bit Windows.
' **********************************************************************************

Option Strict On
Option Explicit On

Imports System.IO
Imports System.Text
Imports System.ComponentModel
Imports System.Runtime.InteropServices

' diese Zeile ist für im FilePreviewControl-Aufgaben -> Bild auswählen ausblenden
' da von PictureBox geerbt
<Designer("System.Windows.Forms.Design.ControlDesigner, System.Design," &
          " Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a")>
Public Class FilePreviewControl
    Inherits PictureBox

#Region "Const"
    Private Const S_OK As Integer = 0
    Private Const E_NOTIMPL As Integer = &H80004001
    Private Const MAX_PATH As Integer = 260
    Private Const FILE_ATTRIBUTE_NORMAL As Integer = 0

    Private Const IID_IOleWindow As String = "00000114-0000-0000-c000-000000000046"
    Private Const IID_IShellItem As String = "43826d1e-e718-42ee-bc55-a1e261c37bfe"
    Private Const IID_IExtractImage As String = "bb2e617c-0920-11d1-9a0b-00c04fc2d6c1"
    Private Const IID_IPreviewHandler As String = "8895b1c6-b41f-4c1c-a562-0d564250836f"
    Private Const IID_IObjectWithSite As String = "fc4801a3-2ba9-11cf-a229-00aa003d7352"
    Private Const IID_IThumbnailProvider As String = "e357fccd-a995-4576-b01f-234630154e96"
    Private Const IID_IInitializeWithFile As String = "b7d14566-0509-4cce-a71f-0a554233bd9b"
    Private Const IID_IInitializeWithItem As String = "7f73be3f-fb79-493c-a6c7-7ee14e245841"
    Private Const IID_IPreviewHandlerFrame As String = "fec87aaf-35f9-447a-adb7-20234491401a"
    Private Const IID_IInitializeWithStream As String = "b824b49d-22ac-4161-ac8a-9916e8fa3f7f"
    Private Const IID_IShellItemImageFactory As String = "bcc18b79-ba16-442f-80c4-8a59c30c463b"
    Private Const IID_IPreviewHandlerVisuals As String = "196bf9a5-b346-4ef0-aa1e-5dcdb76768b1"
#End Region

#Region "Enum"
    Private Enum ASSOCF As Integer
        ASSOCF_NONE = &H0&
        ASSOCF_INIT_NOREMAPCLSID = &H1&
        ASSOCF_INIT_BYEXENAME = &H2&
        ASSOCF_OPEN_BYEXENAME = &H2&
        ASSOCF_INIT_DEFAULTTOSTAR = &H4&
        ASSOCF_INIT_DEFAULTTOFOLDER = &H8&
        ASSOCF_NOUSERSETTINGS = &H10&
        ASSOCF_NOTRUNCATE = &H20&
        ASSOCF_VERIFY = &H40&
        ASSOCF_REMAPRUNDLL = &H80&
        ASSOCF_NOFIXUPS = &H100&
        ASSOCF_IGNOREBASECLASS = &H200&
        ASSOCF_INIT_IGNOREUNKNOWN = &H400&
        ASSOCF_INIT_FIXED_PROGID = &H800&
        ASSOCF_IS_PROTOCOL = &H1000&
        ASSOCF_INIT_FOR_FILE = &H2000&
    End Enum

    Private Enum ASSOCSTR As Integer
        ASSOCSTR_COMMAND = &H1&
        ASSOCSTR_EXECUTABLE = &H2&
        ASSOCSTR_FRIENDLYDOCNAME = &H3&
        ASSOCSTR_FRIENDLYAPPNAME = &H4&
        ASSOCSTR_NOOPEN = &H5&
        ASSOCSTR_SHELLNEWVALUE = &H6&
        ASSOCSTR_DDECOMMAND = &H7&
        ASSOCSTR_DDEIFEXEC = &H8&
        ASSOCSTR_DDEAPPLICATION = &H9&
        ASSOCSTR_DDETOPIC = &HA&
        ASSOCSTR_INFOTIP = &HB&
        ASSOCSTR_QUICKTIP = &HC&
        ASSOCSTR_TILEINFO = &HD&
        ASSOCSTR_CONTENTTYPE = &HE&
        ASSOCSTR_DEFAULTICON = &HF&
        ASSOCSTR_SHELLEXTENSION = &H10&
        ASSOCSTR_DROPTARGET = &H11&
        ASSOCSTR_DELEGATEEXECUTE = &H12&
        ASSOCSTR_SUPPORTED_URI_PROTOCOLS = &H13&
        ASSOCSTR_PROGID = &H14&
        ASSOCSTR_APPID = &H15&
        ASSOCSTR_APPPUBLISHER = &H16&
        ASSOCSTR_APPICONREFERENCE = &H17&
        ASSOCSTR_MAX = &H18&
    End Enum

    Public Enum STGM As Integer
        STGM_FAILIFTHERE = &H0&
        STGM_DIRECT = &H0&
        STGM_READ = &H0&
        STGM_WRITE = &H1&
        STGM_READWRITE = &H2&
        STGM_SHARE_EXCLUSIVE = &H10&
        STGM_SHARE_DENY_WRITE = &H20&
        STGM_SHARE_DENY_READ = &H30&
        STGM_SHARE_DENY_NONE = &H40&
        STGM_CREATE = &H1000&
        STGM_TRANSACTED = &H10000&
        STGM_CONVERT = &H20000&
        STGM_PRIORITY = &H40000&
        STGM_NOSCRATCH = &H100000&
        STGM_NOSNAPSHOT = &H200000&
        STGM_DIRECT_SWMR = &H400000&
        STGM_SIMPLE = &H8000000&
        STGM_DELETEONRELEASE = &H4000000&
    End Enum

    Private Enum WTS_ALPHATYPE As Integer
        WTSAT_UNKNOWN = &H0&
        WTSAT_RGB = &H1&
        WTSAT_ARGB = &H2&
    End Enum

    Private Enum IEI_FLAGS As Integer
        IEI_PRIORITY_NORMAL = &H0&
        IEI_PRIORITY_MIN = &H1&
        IEI_PRIORITY_MAX = &H2&
    End Enum

    Private Enum IEIFLAG_FLAGS As Integer
        IEIFLAG_OFFLINE = &H8&
        IEIFLAG_SCREEN = &H20&
        IEIFLAG_ORIGSIZE = &H40&
        IEIFLAG_QUALITY = &H200&
        IEIFLAG_REFRESH = &H400&
    End Enum

    Public Enum SIIGBF As Integer
        SIIGBF_RESIZETOFIT = &H0&
        SIIGBF_BIGGERSIZEOK = &H1&
        SIIGBF_MEMORYONLY = &H2&
        SIIGBF_ICONONLY = &H4&
        SIIGBF_THUMBNAILONLY = &H8&
        SIIGBF_INCACHEONLY = &H10&
        SIIGBF_CROPTOSQUARE = &H20&
        SIIGBF_WIDETHUMBNAILS = &H40&
        SIIGBF_ICONBACKGROUND = &H80&
        SIIGBF_SCALEUP = &H100&
    End Enum
#End Region

#Region "API"

    <DllImport("Shlwapi.dll", EntryPoint:="AssocQueryStringW")>
    <PreserveSig> Private Shared Function AssocQueryStringW(<[In]> flags As ASSOCF,
                                                            <[In]> str As ASSOCSTR,
                                                            <[In], MarshalAs(UnmanagedType.LPWStr)> pszAssoc As String,
                                                            <[In], MarshalAs(UnmanagedType.LPWStr)> pszExtra As String,
                                                            <[In], Out, MarshalAs(UnmanagedType.LPWStr)> pszOut As StringBuilder,
                                                            <Out> ByRef pcchOut As Integer) As Integer
    End Function

    <DllImport("Shlwapi.dll", EntryPoint:="SHCreateStreamOnFileEx")>
    <PreserveSig> Private Shared Function SHCreateStreamOnFileEx(<[In], MarshalAs(UnmanagedType.LPWStr)> pszFile As String,
                                                                 <[In]> grfMode As STGM,
                                                                 <[In]> dwAttributes As Integer,
                                                                 <[In], MarshalAs(UnmanagedType.Bool)> fCreate As Boolean,
                                                                 <[In]> pstmTemplate As IntPtr,
                                                                 <Out> ByRef ppstm As IntPtr) As Integer
    End Function

    <DllImport("Shlwapi.dll", EntryPoint:="PathCompactPathExW")>
    Private Shared Function PathCompactPathExW(<Out, MarshalAs(UnmanagedType.LPWStr)> pszOut As StringBuilder,
                                               <[In], MarshalAs(UnmanagedType.LPWStr)> pszSrc As String,
                                               <[In]> ccMax As Integer,
                                               <[In]> dwFlags As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
    End Function

    <DllImport("Shell32.dll", EntryPoint:="SHCreateItemFromParsingName")>
    <PreserveSig> Private Shared Function SHCreateItemFromParsingName(<[In], MarshalAs(UnmanagedType.LPWStr)> pszPath As String,
                                                                      <[In]> pbc As IntPtr,
                                                                      <[In], MarshalAs(UnmanagedType.LPStruct)> riid As Guid,
                                                                      <Out> ByRef pUnk As IntPtr) As Integer
    End Function

    <DllImport("Gdi32.dll", EntryPoint:="DeleteObject")>
    Private Shared Function DeleteObject(<[In]> hgdiobj As IntPtr) As <MarshalAs(UnmanagedType.Bool)> Boolean
    End Function
#End Region

#Region "Variable"
    Private m_Bitmap As Bitmap = Nothing
    Private m_PreviewHandler As Object = Nothing
    Private m_Message As String = "Keine Vorschau geladen."
    Private m_PreviewFile As String = String.Empty
    Private m_IPreviewHandlerFrame As IPreviewHandlerFrame = Nothing
#End Region

#Region "New"
    Public Sub New()
        MyBase.New()

        ' diverse Einstellungen für das Control festlegen
        BackColor = Color.White
        ForeColor = Color.Black
        Size = New Size(320, 240)
        BackgroundImageLayout = ImageLayout.Center
        SetStyle(ControlStyles.SupportsTransparentBackColor, True)
        SetStyle(ControlStyles.UserPaint, True)

    End Sub
#End Region

#Region "Overrides Sub"
    Protected Overrides Sub Dispose(ByVal disposing As Boolean)

        ' Alles schließen und löschen
        ClosePreviewHandler()

        MyBase.Dispose(disposing)

    End Sub

    Protected Overrides Sub OnResize(ByVal e As EventArgs)

        MyBase.OnResize(e)

        ' Message ausgeben
        m_Message = "Keine Vorschau geladen."
        Invalidate()

        ' nur wenn ein PreviewHandler vorhanden ist
        If m_PreviewHandler IsNot Nothing Then

            ' ist der PreviewHandler vom Type IPreviewHandler
            If TypeOf m_PreviewHandler Is IPreviewHandler Then

                ' Resize des PreviewHandler
                CType(m_PreviewHandler, IPreviewHandler).SetRect(ClientRectangle)

            End If

        End If

        ' nur wenn ein Bitmap vorhanden ist
        If m_Bitmap IsNot Nothing Then

            ' BackgroundImage löschen
            BackgroundImage = Nothing

            ' Bitmap dispose und löschen
            m_Bitmap.Dispose()
            m_Bitmap = Nothing

            ' Vorschau erneut aufrufen
            ShowPreview()

        End If

    End Sub

    Protected Overrides Sub OnPaint(ByVal e As PaintEventArgs)

        MyBase.OnPaint(e)

        ' nur wenn eine Message vorhanden ist
        If m_Message <> String.Empty Then

            ' Message in das Control zeichnen
            TextRenderer.DrawText(e.Graphics, m_Message, Font, ClientRectangle, ForeColor,
                                  TextFormatFlags.HorizontalCenter Or TextFormatFlags.VerticalCenter Or
                                  TextFormatFlags.WordBreak Or TextFormatFlags.WordEllipsis)
        End If

    End Sub
#End Region

#Region "Overrides Properties"
    <DefaultValue("White")>
    Public Overrides Property BackColor As Color

        Get
            Return MyBase.BackColor
        End Get

        Set(ByVal value As Color)
            MyBase.BackColor = value
        End Set

    End Property

    <Browsable(True), EditorBrowsable(EditorBrowsableState.Always), Bindable(True),
        DesignerSerializationVisibility(DesignerSerializationVisibility.Content), DefaultValue("Black")>
    Public Overrides Property ForeColor As Color

        Get
            Return MyBase.ForeColor
        End Get

        Set(ByVal value As Color)
            MyBase.ForeColor = value
        End Set

    End Property
#End Region

#Region "Hide Properties"
    <Browsable(False), EditorBrowsable(EditorBrowsableState.Never), Bindable(False),
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)>
    Public Overrides Property BackgroundImage As Image
        Get
            Return MyBase.BackgroundImage
        End Get
        Set(value As Image)
            MyBase.BackgroundImage = value
        End Set
    End Property

    <Browsable(False), EditorBrowsable(EditorBrowsableState.Never), Bindable(False),
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)>
    Public Overrides Property BackgroundImageLayout As ImageLayout
        Get
            Return MyBase.BackgroundImageLayout
        End Get
        Set(value As ImageLayout)
            MyBase.BackgroundImageLayout = value
        End Set
    End Property

    <Browsable(False), EditorBrowsable(EditorBrowsableState.Never), Bindable(False),
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)>
    Public Overrides Property ContextMenuStrip As ContextMenuStrip
        Get
            Return MyBase.ContextMenuStrip
        End Get
        Set(value As ContextMenuStrip)
            MyBase.ContextMenuStrip = value
        End Set
    End Property

    <Browsable(False), EditorBrowsable(EditorBrowsableState.Never), Bindable(False),
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)>
    Public Overrides Property ContextMenu As ContextMenu
        Get
            Return MyBase.ContextMenu
        End Get
        Set(value As ContextMenu)
            MyBase.ContextMenu = value
        End Set
    End Property

    <Browsable(False), EditorBrowsable(EditorBrowsableState.Never), Bindable(False),
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)>
    Public Shadows Property Image As Image

    <Browsable(False), EditorBrowsable(EditorBrowsableState.Never), Bindable(False),
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)>
    Public Shadows Property ErrorImage As Bitmap

    <Browsable(False), EditorBrowsable(EditorBrowsableState.Never), Bindable(False),
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)>
    Public Shadows Property InitialImage As Bitmap

    <Browsable(False), EditorBrowsable(EditorBrowsableState.Never), Bindable(False),
        DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)>
    Public Shadows Property ImageLocation As String

#End Region

#Region "Public Properties"
    ' Datei für der ein Preview geladen werden soll
    Public Property PreviewFile() As String

        Get
            PreviewFile = m_PreviewFile
        End Get

        Set(value As String)
            m_PreviewFile = value
        End Set

    End Property
#End Region

#Region "Public Functions"
    Public Sub ClosePreview()

        ' Alles schließen und löschen
        ClosePreviewHandler()

        ' Message ausgeben
        m_Message = "Keine Vorschau geladen."
        Invalidate()

    End Sub

    Public Function ShowPreview() As Boolean

        Dim bolRet As Boolean = False
        Dim strHandlerClsid As String = String.Empty

        ' Alles schließen und löschen
        ClosePreviewHandler()

        ' wenn die Datei nicht existiert
        If Not File.Exists(m_PreviewFile) Then

            ' Message ausgeben
            m_Message = "Die Datei '" & CompactPath(m_PreviewFile, 40) & "' existiert nicht!"
            Invalidate()

            '  dann können wir hier raus aus der Funktion
            Return False

        End If

        ' Message ausgeben
        m_Message = "Preview wird geladen..."
        Invalidate()

        ' Versuche einen PreviewHandler für IPreviewHandler zu finden
        If GetHandlerClsidFromFile(m_PreviewFile, IID_IPreviewHandler, strHandlerClsid) Then

            ' PreviewHandler erstellen
            m_PreviewHandler = Activator.CreateInstance(Type.GetTypeFromCLSID(New Guid(strHandlerClsid)))

            ' PreviewHandler initialisieren
            If InitializePreviewHandler(m_PreviewHandler, m_PreviewFile) Then

                ' ist der PreviewHandler vom Type IPreviewHandler
                If TypeOf m_PreviewHandler Is IPreviewHandler Then

                    ' PreviewHandler zu IPreviewHandler ändern
                    Dim oIPreviewHandler As IPreviewHandler = CType(m_PreviewHandler, IPreviewHandler)

                    ' IPreviewHandler ein Fensterhandle und Position zuweisen
                    If oIPreviewHandler.SetWindow(Handle, ClientRectangle) = S_OK Then

                        ' Optional: wird nicht von allen PreviewHandlern ünterstützt!
                        ' ist der IPreviewHandler vom Type IPreviewHandlerVisuals
                        If TypeOf oIPreviewHandler Is IPreviewHandlerVisuals Then

                            ' IPreviewHandler zu IPreviewHandlerVisuals ändern
                            Dim oIPreviewHandlerVisuals As IPreviewHandlerVisuals =
                               CType(oIPreviewHandler, IPreviewHandlerVisuals)

                            ' Farbe für den Hintergrund setzen
                            oIPreviewHandlerVisuals.SetBackgroundColor(BackColor.ToArgb)

                            ' Farbe für die Schrift setzen
                            oIPreviewHandlerVisuals.SetTextColor(ForeColor.ToArgb)

                            ' hab ich nicht implementiert
                            'oIPreviewHandlerVisuals.SetFont()

                        End If

                        ' Optional: brauch man das wirklich?
                        ' ist der PreviewHandler vom Type IOleWindow
                        If TypeOf oIPreviewHandler Is IOleWindow Then

                            ' PreviewHandler zu IOleWindow ändern
                            Dim oIOleWindow As IOleWindow = CType(oIPreviewHandler, IOleWindow)

                            Dim pHwnd As IntPtr
                            If oIOleWindow.GetWindow(pHwnd) = S_OK Then
                                'Debug.Print(pHwnd.ToString)
                            End If

                            If oIOleWindow.ContextSensitiveHelp(False) = E_NOTIMPL Then
                                'Debug.Print("PreviewHandler haben keine ContextSensitive Hilfe!")
                            End If

                        End If

                        ' Optional: brauch man das wirklich?
                        ' ist der PreviewHandler vom Type IObjectWithSite
                        If TypeOf oIPreviewHandler Is IObjectWithSite Then

                            ' PreviewHandler zu IObjectWithSite ändern
                            Dim oIObjectWithSite As IObjectWithSite = CType(oIPreviewHandler, IObjectWithSite)

                            Dim oIPreviewHandlerFrame As Object = Nothing
                            If oIObjectWithSite.GetSite(New Guid(IID_IPreviewHandlerFrame), oIPreviewHandlerFrame) = S_OK Then
                                If m_IPreviewHandlerFrame IsNot Nothing Then
                                    Marshal.ReleaseComObject(m_IPreviewHandlerFrame)
                                End If
                                m_IPreviewHandlerFrame = CType(oIPreviewHandlerFrame, IPreviewHandlerFrame)
                            End If

                            If m_IPreviewHandlerFrame IsNot Nothing Then
                                If oIObjectWithSite.SetSite(m_IPreviewHandlerFrame) = S_OK Then
                                    'Debug.Print("Ok")
                                End If
                            End If

                        End If

                        ' Optional: brauch man das wirklich?
                        If m_IPreviewHandlerFrame IsNot Nothing Then
                            Dim pMsg As IntPtr
                            If oIPreviewHandler.TranslateAccelerator(pMsg) = S_OK Then
                                If m_IPreviewHandlerFrame.TranslateAccelerator(pMsg) = S_OK Then
                                    'Debug.Print("Ok")
                                End If
                            End If
                        End If

                        ' nochmal die Position zuweisen, da es bei einigen PreviewHandlern
                        ' sonst zu falscher Positionierung kommt
                        If oIPreviewHandler.SetRect(ClientRectangle) = S_OK Then

                            ' Preview anzeigen
                            If oIPreviewHandler.DoPreview = S_OK Then

                                ' Message löschen
                                m_Message = String.Empty
                                Invalidate()

                                bolRet = True

                            End If

                        End If

                    End If

                End If

            End If

            ' Versuche einen PreviewHandler für IThumbnailProvider zu finden
        ElseIf GetHandlerClsidFromFile(m_PreviewFile, IID_IThumbnailProvider, strHandlerClsid) Then

            ' PreviewHandler erstellen
            m_PreviewHandler = Activator.CreateInstance(Type.GetTypeFromCLSID(New Guid(strHandlerClsid)))

            ' PreviewHandler initialisieren
            If InitializePreviewHandler(m_PreviewHandler, m_PreviewFile) Then

                ' ist der PreviewHandler vom Type IThumbnailProvider
                If TypeOf m_PreviewHandler Is IThumbnailProvider Then

                    ' PreviewHandler zu IThumbnailProvider ändern
                    Dim oIThumbnailProvider As IThumbnailProvider = CType(m_PreviewHandler, IThumbnailProvider)

                    ' Größe des Thumbnail festlegen
                    Dim intX As Integer = Clamp(ClientRectangle.Width, 10, ClientRectangle.Width - 50)
                    Dim intY As Integer = Clamp(ClientRectangle.Height, 10, ClientRectangle.Height - 50)

                    Dim hBitmap As IntPtr
                    Dim dwAlpha As WTS_ALPHATYPE

                    ' Thumbnail laden
                    If oIThumbnailProvider.GetThumbnail(Math.Min(intX, intY), hBitmap, dwAlpha) = S_OK Then

                        ' ist ein GDI32-BitmapHandle vorhanden
                        If hBitmap <> IntPtr.Zero Then

                            ' Message löschen
                            m_Message = String.Empty
                            Invalidate()

                            ' GDI+ Bitmap vom GDI32-BitmapHandle erstellen
                            m_Bitmap = Bitmap.FromHbitmap(hBitmap)

                            ' BackgroundImageLayout festlegen
                            BackgroundImageLayout = ImageLayout.Center

                            ' GDI+ Bitmap zuweisen
                            BackgroundImage = m_Bitmap

                            ' GDI32-BitmapHandle löschen
                            DeleteObject(hBitmap)

                            bolRet = True

                        End If

                    End If

                End If

            End If

            ' Versuche einen PreviewHandler für IExtractImage zu finden
        ElseIf GetHandlerClsidFromFile(m_PreviewFile, IID_IExtractImage, strHandlerClsid) Then

            ' PreviewHandler erstellen
            m_PreviewHandler = Activator.CreateInstance(Type.GetTypeFromCLSID(New Guid(strHandlerClsid)))

            ' PreviewHandler initialisieren
            If InitializePreviewHandler(m_PreviewHandler, m_PreviewFile) Then

                ' ist der PreviewHandler vom Type IExtractImage
                If TypeOf m_PreviewHandler Is IExtractImage Then

                    ' PreviewHandler zu IExtractImage ändern
                    Dim oIExtractImage As IExtractImage = CType(m_PreviewHandler, IExtractImage)

                    ' diver Eigenschaften festlegen
                    Dim sbBuffer As New StringBuilder(MAX_PATH)
                    Dim ePriority As IEI_FLAGS = IEI_FLAGS.IEI_PRIORITY_NORMAL
                    Dim eFlags As IEIFLAG_FLAGS = IEIFLAG_FLAGS.IEIFLAG_QUALITY
                    Dim intColorDepth As Integer = 32 '32bit 

                    ' Größe des Image festlegen
                    Dim intX As Integer = Clamp(ClientRectangle.Width, 10, ClientRectangle.Width - 50)
                    Dim intY As Integer = Clamp(ClientRectangle.Height, 10, ClientRectangle.Height - 50)

                    ' Location des Images ermitteln, muss aufgerufen werden
                    If oIExtractImage.GetLocation(sbBuffer, sbBuffer.Capacity, ePriority,
                                                  New Size(intX, intY), intColorDepth, eFlags) = S_OK Then

                        Dim hBitmap As IntPtr

                        ' Image laden
                        If oIExtractImage.Extract(hBitmap) = S_OK Then

                            ' ist ein GDI32-BitmapHandle vorhanden
                            If hBitmap <> IntPtr.Zero Then

                                ' Message löschen
                                m_Message = String.Empty
                                Invalidate()

                                ' GDI+ Bitmap vom GDI32-BitmapHandle erstellen
                                m_Bitmap = Bitmap.FromHbitmap(hBitmap)

                                ' BackgroundImageLayout festlegen
                                BackgroundImageLayout = ImageLayout.Center

                                ' GDI+ Bitmap zuweisen
                                BackgroundImage = m_Bitmap

                                ' GDI32-BitmapHandle löschen
                                DeleteObject(hBitmap)

                                bolRet = True

                            End If

                        End If

                    End If

                End If

            End If

        End If

        ' Message anzeigen das der Preview über einen PreviewHandler
        If Not bolRet Then

            ' Message ausgeben
            m_Message = "Für die Datei '" & m_PreviewFile & "' ist keine Vorschau möglich."
            Invalidate()

        End If

        Return bolRet

    End Function
#End Region

#Region "Private Functions"

    ' Begrenzt einen Wert auf einen minimalen oder maximalen Wert
    Private Function Clamp(Value As Integer, Min As Integer, Max As Integer) As Integer

        If Value <= Min Then Return Min
        If Value >= Max Then Return Max
        Return Value

    End Function

    ' langen Pfad kürzen
    Private Function CompactPath(strPath As String, intMaxChars As Integer) As String

        Dim strRet As String = strPath
        Dim sbBuffer As New StringBuilder(MAX_PATH)

        If PathCompactPathExW(sbBuffer, strPath, intMaxChars, 0) Then
            strRet = sbBuffer.ToString
        End If

        Return strRet

    End Function

    ' alles schließen und löschen 
    Private Sub ClosePreviewHandler()

        ' ist ein Bitmap vorhanden
        If m_Bitmap IsNot Nothing Then

            ' BackgroundImage löschen
            BackgroundImage = Nothing

            ' Bitmap löschen
            m_Bitmap.Dispose()
            m_Bitmap = Nothing
        End If

        ' ist ein PreviewHandler vorhanden
        If m_PreviewHandler IsNot Nothing Then

            ' ist der PreviewHandler vom Type IPreviewHandler
            If TypeOf m_PreviewHandler Is IPreviewHandler Then

                ' PreviewHandler schließen
                CType(m_PreviewHandler, IPreviewHandler).Unload()

            End If

            ' PreviewHandler löschen
            Marshal.ReleaseComObject(m_PreviewHandler)
            m_PreviewHandler = Nothing

        End If

        ' Message löschen und Ausgabe aktualisieren
        m_Message = String.Empty
        Invalidate()

    End Sub

    ' initialisiert einen PreviewHandler
    Private Function InitializePreviewHandler(oPreviewHandler As Object,
                                              strFileName As String) As Boolean
        Dim bolRet As Boolean = False

        ' Versuch über IInitializeWithStream
        ' ist der PreviewHandler vom Type IInitializeWithStream
        If TypeOf oPreviewHandler Is IInitializeWithStream Then

            Dim pIStream As IntPtr

            ' ein IStream von der Datei erstellen
            If SHCreateStreamOnFileEx(strFileName, STGM.STGM_READ, FILE_ATTRIBUTE_NORMAL,
                                      False, IntPtr.Zero, pIStream) = S_OK Then

                ' PreviewHandler mit einem IStream initialisieren
                If CType(oPreviewHandler, IInitializeWithStream).Initialize(pIStream, STGM.STGM_READ) = S_OK Then

                    bolRet = True

                End If

                ' IStream löschen
                Marshal.Release(pIStream)
            End If

            ' Versuch über IInitializeWithFile
            ' ist der PreviewHandler vom Type IInitializeWithFile
        ElseIf TypeOf oPreviewHandler Is IInitializeWithFile Then

            ' PreviewHandler direkt mit einer Datei initialisieren
            If CType(oPreviewHandler, IInitializeWithFile).Initialize(strFileName, STGM.STGM_READ) = S_OK Then

                bolRet = True

            End If

            ' Versuch über IInitializeWithItem
            ' ist der PreviewHandler vom Type IInitializeWithItem
        ElseIf TypeOf oPreviewHandler Is IInitializeWithItem Then

            Dim pIShellItem As IntPtr

            ' ein IShellItem von der Datei erstellen
            If SHCreateItemFromParsingName(strFileName, IntPtr.Zero,
                                           New Guid(IID_IShellItem), pIShellItem) = S_OK Then

                ' PreviewHandler mit einem IShellItem initialisieren
                If CType(oPreviewHandler, IInitializeWithItem).Initialize(pIShellItem, STGM.STGM_READ) = S_OK Then

                    bolRet = True

                End If

                ' IShellItem löschen
                Marshal.Release(pIShellItem)

            End If

        End If

        Return bolRet

    End Function

    ' PreviewHandler-CLSID von der Datei ermitteln
    Private Function GetHandlerClsidFromFile(strFileName As String,
                                             strHandlerIID As String,
                                             ByRef strHandlerClsid As String) As Boolean

        Dim bolRet As Boolean = False

        ' Dateierweiterung der Datei auslesen
        Dim strFileExt As String = Path.GetExtension(strFileName).Substring(1)

        ' CLSID für den PreviewHandler für die Dateierweiterung ermitteln
        Dim strClsid As String = GetHandlerClsidFromFileExt("." & strFileExt, strHandlerIID)

        ' wenn es keine CLSID per Dateierweiterung gibt, schauen ob es eine andere CLSID gibt
        If strClsid.Length = 0 Then strClsid = GetHandlerClsidFromFileExt(strFileExt & "file", strHandlerIID)

        ' es gibt eine CLSID
        If strClsid.Length = 38 Then

            strHandlerClsid = strClsid

            bolRet = True

        End If

        Return bolRet

    End Function

    ' PreviewHandler-CLSID von der Dateierweiterung ermitteln
    Private Function GetHandlerClsidFromFileExt(strFileExt As String,
                                                strHandlerIID As String) As String

        Dim intOut As Integer
        Dim strRet As String = String.Empty

        intOut = 64

        ' Puffer
        Dim sbClsid As New StringBuilder(intOut + 1)

        ' CLSID passend zur Handler-IID ermitteln
        If AssocQueryStringW(ASSOCF.ASSOCF_NONE, ASSOCSTR.ASSOCSTR_SHELLEXTENSION,
                             strFileExt, "{" & strHandlerIID & "}", sbClsid, intOut) = S_OK Then

            ' ist eine CLSID vorhanden, dann CLSID aus dem Puffer
            If intOut > 0 Then strRet = sbClsid.ToString

        End If

        Return strRet

    End Function
#End Region

#Region "Interface IOleWindow"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_IOleWindow)>
    Private Interface IOleWindow

        <PreserveSig> Function GetWindow(<Out> ByRef phwnd As IntPtr) As Integer

        <PreserveSig> Function ContextSensitiveHelp(<[In], MarshalAs(UnmanagedType.Bool)> fEnterMode As Boolean) As Integer

    End Interface
#End Region

#Region "Interface IExtractImage"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_IExtractImage)>
    Private Interface IExtractImage

        <PreserveSig> Function GetLocation(<Out, MarshalAs(UnmanagedType.LPWStr)> pszPathBuffer As StringBuilder,
                                           <[In]> cch As Integer,
                                           <[In], Out> ByRef pdwPriority As IEI_FLAGS,
                                           <[In]> ByRef prgSize As Size,
                                           <[In]> dwRecClrDepth As Integer,
                                           <[In], Out> ByRef pdwFlags As IEIFLAG_FLAGS) As Integer

        <PreserveSig> Function Extract(<Out> ByRef phBmpThumbnail As IntPtr) As Integer

    End Interface
#End Region

#Region "Interface IObjectWithSite"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_IObjectWithSite)>
    Private Interface IObjectWithSite

        <PreserveSig> Function SetSite(<[In], MarshalAs(UnmanagedType.IUnknown)> pUnkSite As Object) As Integer

        <PreserveSig> Function GetSite(<[In]> ByRef riid As Guid,
                                       <Out, MarshalAs(UnmanagedType.IUnknown)> ByRef ppvSite As Object) As Integer

    End Interface
#End Region

#Region "Interface IPreviewHandler"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_IPreviewHandler)>
    Private Interface IPreviewHandler
        <PreserveSig> Function SetWindow(<[In]> hwnd As IntPtr,
                                         <[In]> ByRef prc As Rectangle) As Integer

        <PreserveSig> Function SetRect(<[In]> ByRef prc As Rectangle) As Integer

        <PreserveSig> Function DoPreview() As Integer

        <PreserveSig> Function Unload() As Integer

        <PreserveSig> Function SetFocus() As Integer

        <PreserveSig> Function QureyFocus(<Out> ByRef phwnd As IntPtr) As Integer

        <PreserveSig> Function TranslateAccelerator(<Out> ByRef pmsg As IntPtr) As Integer

    End Interface
#End Region

#Region "Interface IThumbnailProvider"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_IThumbnailProvider)>
    Private Interface IThumbnailProvider
        <PreserveSig> Function GetThumbnail(<[In]> cx As Integer,
                                            <Out> ByRef phbmp As IntPtr,
                                            <Out> ByRef pdwAlpha As WTS_ALPHATYPE) As Integer
    End Interface
#End Region

#Region "Interface IInitializeWithFile"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_IInitializeWithFile)>
    Private Interface IInitializeWithFile
        <PreserveSig> Function Initialize(<[In], MarshalAs(UnmanagedType.LPWStr)> pszFilePath As String,
                                          <[In]> grfMode As STGM) As Integer
    End Interface
#End Region

#Region "Interface IInitializeWithItem"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_IInitializeWithItem)>
    Private Interface IInitializeWithItem
        <PreserveSig> Function Initialize(<[In]> psi As IntPtr,
                                          <[In]> grfMode As STGM) As Integer
    End Interface
#End Region

#Region "Interface IPreviewHandlerFrame"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_IPreviewHandlerFrame)>
    Private Interface IPreviewHandlerFrame

        <PreserveSig> Function GetWindowContext(<Out> pinfo As IntPtr) As Integer

        <PreserveSig> Function TranslateAccelerator(<[In]> pmsg As IntPtr) As Integer

    End Interface
#End Region

#Region "Interface IInitializeWithStream"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_IInitializeWithStream)>
    Private Interface IInitializeWithStream
        <PreserveSig> Function Initialize(<[In]> pstream As IntPtr,
                                          <[In]> grfMode As STGM) As Integer
    End Interface
#End Region

#Region "Interface IPreviewHandlerVisuals"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_IPreviewHandlerVisuals)>
    Private Interface IPreviewHandlerVisuals

        <PreserveSig> Function SetBackgroundColor(<[In]> color As Integer) As Integer

        <PreserveSig> Function SetFont(<[In]> plf As IntPtr) As Integer

        <PreserveSig> Function SetTextColor(<[In]> color As Integer) As Integer

    End Interface
#End Region

#Region "Interface IShellItemImageFactory"
    <ComImport>
    <InterfaceType(ComInterfaceType.InterfaceIsIUnknown)>
    <Guid(IID_IShellItemImageFactory)>
    Private Interface IShellItemImageFactory
        <PreserveSig> Function GetImage(<[In]> size As Size,
                                        <[In]> flags As SIIGBF,
                                        <Out> ByRef phbm As IntPtr) As Integer
    End Interface
#End Region

End Class
